/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TDmTabledef.TDmTabledefPath;
import de.ship.db.tables.records.TDmTablecopyRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmTablecopy extends TableImpl<TDmTablecopyRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_tablecopy</code>
     */
    public static final TDmTablecopy T_DM_TABLECOPY = new TDmTablecopy();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmTablecopyRecord> getRecordType() {
        return TDmTablecopyRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_tablecopy.lastchange</code>.
     */
    public final TableField<TDmTablecopyRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_tablecopy.pk</code>.
     */
    public final TableField<TDmTablecopyRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_tablecopy.fk_tabledef</code>. reference
     * to t_dm_tabledef.pk
     */
    public final TableField<TDmTablecopyRecord, Integer> FK_TABLEDEF = createField(DSL.name("fk_tabledef"), SQLDataType.INTEGER.nullable(false), this, "reference to t_dm_tabledef.pk");

    /**
     * The column <code>common_dd.t_dm_tablecopy.sourceschema</code>. name of
     * database schema that contains table to be copied
     */
    public final TableField<TDmTablecopyRecord, String> SOURCESCHEMA = createField(DSL.name("sourceschema"), SQLDataType.CLOB.nullable(false), this, "name of database schema that contains table to be copied");

    private TDmTablecopy(Name alias, Table<TDmTablecopyRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmTablecopy(Name alias, Table<TDmTablecopyRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tablecopy</code> table reference
     */
    public TDmTablecopy(String alias) {
        this(DSL.name(alias), T_DM_TABLECOPY);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tablecopy</code> table reference
     */
    public TDmTablecopy(Name alias) {
        this(alias, T_DM_TABLECOPY);
    }

    /**
     * Create a <code>common_dd.t_dm_tablecopy</code> table reference
     */
    public TDmTablecopy() {
        this(DSL.name("t_dm_tablecopy"), null);
    }

    public <O extends Record> TDmTablecopy(Table<O> path, ForeignKey<O, TDmTablecopyRecord> childPath, InverseForeignKey<O, TDmTablecopyRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_TABLECOPY);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmTablecopyPath extends TDmTablecopy implements Path<TDmTablecopyRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmTablecopyPath(Table<O> path, ForeignKey<O, TDmTablecopyRecord> childPath, InverseForeignKey<O, TDmTablecopyRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmTablecopyPath(Name alias, Table<TDmTablecopyRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmTablecopyPath as(String alias) {
            return new TDmTablecopyPath(DSL.name(alias), this);
        }

        @Override
        public TDmTablecopyPath as(Name alias) {
            return new TDmTablecopyPath(alias, this);
        }

        @Override
        public TDmTablecopyPath as(Table<?> alias) {
            return new TDmTablecopyPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmTablecopyRecord, Integer> getIdentity() {
        return (Identity<TDmTablecopyRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmTablecopyRecord> getPrimaryKey() {
        return Keys.PK_DM_TABLECOPY;
    }

    @Override
    public List<UniqueKey<TDmTablecopyRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_TABLECOPY);
    }

    @Override
    public List<ForeignKey<TDmTablecopyRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_TABLECOPY__FK_TABLECOPY_TABLEDEF);
    }

    private transient TDmTabledefPath _tDmTabledef;

    /**
     * Get the implicit join path to the <code>common_dd.t_dm_tabledef</code>
     * table.
     */
    public TDmTabledefPath tDmTabledef() {
        if (_tDmTabledef == null)
            _tDmTabledef = new TDmTabledefPath(this, Keys.T_DM_TABLECOPY__FK_TABLECOPY_TABLEDEF, null);

        return _tDmTabledef;
    }

    @Override
    public TDmTablecopy as(String alias) {
        return new TDmTablecopy(DSL.name(alias), this);
    }

    @Override
    public TDmTablecopy as(Name alias) {
        return new TDmTablecopy(alias, this);
    }

    @Override
    public TDmTablecopy as(Table<?> alias) {
        return new TDmTablecopy(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablecopy rename(String name) {
        return new TDmTablecopy(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablecopy rename(Name name) {
        return new TDmTablecopy(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTablecopy rename(Table<?> name) {
        return new TDmTablecopy(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablecopy where(Condition condition) {
        return new TDmTablecopy(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablecopy where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablecopy where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablecopy where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablecopy where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablecopy where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablecopy where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTablecopy where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablecopy whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTablecopy whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
